import java.lang.reflect.Method;
/**
 * Klasse LoopThread, um angegebene Methoden fortlaufend zu wiederholen
 * 
 * @author Carsten Mller
 * @version 31.03.2011
 */
public class LoopThread extends Thread
{
    private Object objekt;
    private Method methode;
    private String methodenname;
    private int millisekunden;
    private volatile Thread t;
    private boolean einmal = false;

    /**
     * Konstruktor
     */
    public LoopThread(Object objekt, Method methode, String methodenname, int millisekunden)
    {
        this.methode=methode;
        this.objekt=objekt;
        this.methodenname=methodenname;
        this.millisekunden=millisekunden;
        t=this;
    }
    
    public LoopThread(Object objekt, Method methode, String methodenname, int millisekunden, boolean status)
    {
        this.methode=methode;
        this.objekt=objekt;
        this.methodenname=methodenname;
        this.millisekunden=millisekunden;
        t=this;
        einmal = status;
    }

    
    /**
     * berschriebene Methode der Klasse Thread, die mit start() gestartet wird
     */
    public void run() {
        Thread thisThread = Thread.currentThread();
        if (!einmal){
            while (t==thisThread) {
                try {
                    methode.invoke(objekt);
                    if (millisekunden!=0) {
                        //                   k.pause(millisekunden);
                    }                   
                }
                catch (Exception e) {
                    System.out.println(e);
                }
            }
        }
        else{
            try {
                methode.invoke(objekt);
                if (millisekunden!=0) {
                    //                   k.pause(millisekunden);
                }                   
            }
            catch (Exception e) {
                System.out.println(e);
            }
            stopp();
        }
    }
    
    
    /**
     * LoopThread stoppen
     */
    public void stopp() { 
        t=null;
    }
    
    
    /**
     * Name der aktuellen Methode zurckgegeben
     * @return Mehtodenname
     */
    public String getMethodenname() {
        return methodenname;
    }


}
