import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;

/**
 *
 * @author Boss
 */
public class View extends javax.swing.JPanel {

    private int breiteStrasse = 240;
    private int rundung = 40;
    private int breiteFussweg = 40;
    private int bStreifen = 4;
    private Led[] listeLeds;
    private static Button[] listeButtons;
    private Color farbeStrae = Color.darkGray;
    private Color farbeRadweg = new Color(204, 204, 204); // Color.gray;
    private Color farbeUmrandung = Color.white;
    private Color farbeHintergrund = new Color(88, 204, 0); //   Color.green; //this.getBackground();
    private Color farbeAmpel = new Color(0, 102, 0);
    private Color farbeSteuerkasten = new Color(204, 204, 204);
    private Color rot = Color.red;
    private Color gelb = Color.yellow;
    private Color gruen = Color.green;
    private boolean meldung = false;
    private int indexButton = -1;

    public int getIndexButton() {
        return indexButton;
    }

    public static Button[] getListButtons() {
        return listeButtons;
    }

    public static void setListButtons(Button[] listeButtons) {
        View.listeButtons = listeButtons;
    }

    public void setListLeds(Led[] lampen) {
        this.listeLeds = lampen;
    }

    public Led[] getListLeds() {
        return listeLeds;
    }

    public void paint(Graphics g) {
        hintergrund(g);
        strasseOstWest(g);
        strasseNordSued(g);
        umrandungLinksOben(g);
        umrandungRechtsOben(g);
        umrandungLinksUnten(g);
        umrandungRechtsUnten(g);
        fahrbahnmarkierungenOstWest(g);
        fahrbahnmarkierungenNordSued(g);
        zebrastreifen(g);
        strassenampeln(g);
        fussgaengerampelnNS(g);
        fussgaengerampelnOW(g);
        leds(g);
        steuerkasten(g);
        buttons(g);
        schriftzug(g);
    }

    private void steuerkasten(Graphics g) {
        int x = this.getX() + getWidth() / 2 + 180;
        int y = this.getY() + getHeight() / 2 - 250;
        int b = 80;
        int h = 50;
        int dx = 5;
        int dy = 10;
        g.setColor(farbeSteuerkasten);
        g.fillRect(x, y, b, h);
        g.setColor(Color.black);
        g.drawRect(x, y, b, h);
        g.setColor(Color.BLACK);
        g.drawString("Steuerkasten", x + dx, y + dy + 1);
        //Button 9
        int index = 8;
        listeButtons[index].setX(x + dx * 2 + 2);
        listeButtons[index].setY(y + dy * 3 - 4);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + dx * 2 + 6, y + dy * 2 + 3);
        //Button 10
        index = 9;
        listeButtons[index].setX(x + dx * 9 + 2);
        listeButtons[index].setY(y + dy * 3 - 4);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + dx * 9 + 2, y + dy * 2 + 3);
    }

    private void schriftzug(Graphics g1) {
        Graphics2D g = (Graphics2D) g1;
        g.setColor(farbeSteuerkasten);
        g.fillRect(0, 0, 185, 60);
        Font font = new java.awt.Font("Times New Roman", Font.BOLD, 30);
        g.setFont(font);
        g.setColor(rot);
        g.drawString("Ampelanlage", 10, 25);
        font = new java.awt.Font("Times New Roman", Font.BOLD, 15);
        g.setFont(font);
        g.setColor(Color.BLACK);
        g.drawString("Entwurf: R. Martin, EGF", 10, 50);

    }

    private void leds(Graphics g) {
        for (int i = 0; i < listeLeds.length; i++) {
            Led l = listeLeds[i];
            g.setColor(l.getColor());
            g.fillOval(l.getX(), l.getY(), l.getSize(), l.getSize());
        }
    }

    private void buttons(Graphics g) {
        for (int i = 0; i < listeButtons.length; i++) {
            Button l = listeButtons[i];
            int x = l.getX();
            int y = l.getY();
            int b = l.getB();
            int h = l.getH();
            g.setColor(l.getColorCase());
            g.fillRect(x, y, b, h);
            g.setColor(l.getColorTaste());
            int d = 3;
            g.fillOval(x + d, y + d, b - 2 * d, h - 2 * d);
            g.setColor(Color.black);
            g.drawRect(x, y, b, h);
        }
    }

    private void strassenampeln(Graphics g) {
        int mX = this.getX() + getWidth() / 2;
        int mY = this.getY() + getHeight() / 2;
        int dx = 4;
        int dy = 90;
        int b = 20;
        int dDach = 10;
        int hDach = 10;
        int dLed = 3;
        int groesse = b - dLed * 2;
        int h = (1 + groesse) * 3 + 2;

        //Straenampel rechts unten --> LEDs 0, 1, 2
        g.setColor(farbeAmpel);
        int x = mX + breiteStrasse / 2 + dx;
        int y = mY + breiteStrasse / 2 + dy;
        g.fillRect(x, y, b, h);
        int[] x1 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y1 = {y, y, y - hDach};
        g.fillPolygon(x1, y1, 3);
        listeLeds[0].setSize(groesse);
        listeLeds[1].setSize(groesse);
        listeLeds[2].setSize(groesse);
        listeLeds[0].setX(x + dLed);
        listeLeds[1].setX(x + dLed);
        listeLeds[2].setX(x + dLed);
        listeLeds[0].setY(y);
        listeLeds[1].setY(y + (1 + groesse) * 1);
        listeLeds[2].setY(y + (1 + groesse) * 2);
        listeLeds[0].setColorOn(rot);
        listeLeds[1].setColorOn(gelb);
        listeLeds[2].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("1", x + b + 3, y + (1 + groesse) * 1 - 2);
        g.drawString("2", x + b + 3, y + (1 + groesse) * 2 - 2);
        g.drawString("3", x + b + 3, y + (1 + groesse) * 3 - 2);

        //Straenampel links oben --> LEDs 6, 7, 8
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx - b;
        y = mY - breiteStrasse / 2 - dy - h;
        g.fillRect(x, y, b, h);
        int[] x3 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y3 = {y + h, y + h, y + h + hDach};
        g.fillPolygon(x3, y3, 3);
        listeLeds[6].setSize(groesse);
        listeLeds[7].setSize(groesse);
        listeLeds[8].setSize(groesse);
        listeLeds[6].setX(x + dLed);
        listeLeds[7].setX(x + dLed);
        listeLeds[8].setX(x + dLed);
        listeLeds[6].setY(y + (1 + groesse) * 2);
        listeLeds[7].setY(y + (1 + groesse) * 1);
        listeLeds[8].setY(y + (1 + groesse) * 0);
        listeLeds[6].setColorOn(rot);
        listeLeds[7].setColorOn(gelb);
        listeLeds[8].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("7", x - b / 2, y + h - (1 + groesse) * 0 - 3);
        g.drawString("8", x - b / 2, y + h - (1 + groesse) * 1 - 3);
        g.drawString("9", x - b / 2, y + h - (1 + groesse) * 2 - 3);

        //Straenampel rechts oben --> LEDs 3, 4, 5
        dx = 96;
        dy = 5 + b;
        g.setColor(farbeAmpel);
        x = mX + breiteStrasse / 2 + dx + h;
        y = mY - breiteStrasse / 2 - dy;
        g.fillRect(x, y, h, b);
        int[] x2 = {x, x, x - hDach};
        int[] y2 = {y - dDach, y + b + hDach, y + b / 2};
        g.fillPolygon(x2, y2, 3);
        listeLeds[3].setSize(groesse);
        listeLeds[4].setSize(groesse);
        listeLeds[5].setSize(groesse);
        listeLeds[3].setX(x + (1 + groesse) * 0);
        listeLeds[4].setX(x + (1 + groesse) * 1);
        listeLeds[5].setX(x + (1 + groesse) * 2);
        listeLeds[3].setY(y + dLed - 1);
        listeLeds[4].setY(y + dLed - 1);
        listeLeds[5].setY(y + dLed - 1);
        listeLeds[3].setColorOn(rot);
        listeLeds[4].setColorOn(gelb);
        listeLeds[5].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("4", x + 3 + (1 + groesse) * 0, y - 3);
        g.drawString("5", x + 3 + (1 + groesse) * 1, y - 3);
        g.drawString("6", x + 3 + (1 + groesse) * 2, y - 3);

        //Straenampel links unten --> LEDs 9, 10, 11
        dx = 180;
        dy = 5;
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx;
        y = mY + breiteStrasse / 2 + dy;
        g.fillRect(x, y, h, b);
        int[] x4 = {x + h, x + h, x + h + hDach};
        int[] y4 = {y - dDach, y + b + hDach, y + b / 2};
        g.fillPolygon(x4, y4, 3);
        listeLeds[9].setSize(groesse);
        listeLeds[10].setSize(groesse);
        listeLeds[11].setSize(groesse);
        listeLeds[9].setX(x + 2 + (1 + groesse) * 2);
        listeLeds[10].setX(x + 2 + (1 + groesse) * 1);
        listeLeds[11].setX(x + 2 + (1 + groesse) * 0);
        listeLeds[9].setY(y + dLed);
        listeLeds[10].setY(y + dLed);
        listeLeds[11].setY(y + dLed);
        listeLeds[9].setColorOn(rot);
        listeLeds[10].setColorOn(gelb);
        listeLeds[11].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("10", x + 2 + (1 + groesse) * 2, y + b + 12);
        g.drawString("11", x + 0 + (1 + groesse) * 1, y + b + 12);
        g.drawString("12", x - 2 + (1 + groesse) * 0, y + b + 12);

    }

    private void fussgaengerampelnNS(Graphics g) {
        int mX = this.getX() + getWidth() / 2;
        int mY = this.getY() + getHeight() / 2;
        int dx = 90;
        int dy = 28;
        int b = 16;
        int dDach = 5;
        int hDach = 5;
        int dLed = 3;
        int groesse = b - dLed * 2;
        int h = (1 + groesse) * 2 + 2;

        //Fussgngerampel r o NS --> LEDs 12, 13
        g.setColor(farbeAmpel);
        int x = mX + breiteStrasse / 2 + dx;
        int y = mY - breiteStrasse / 2 - dy;
        g.fillRect(x, y, b, h);
        int[] x1 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y1 = {y, y, y - hDach};
        g.fillPolygon(x1, y1, 3);
        listeLeds[12].setSize(groesse);
        listeLeds[13].setSize(groesse);
        listeLeds[12].setX(x + dLed);
        listeLeds[13].setX(x + dLed);
        listeLeds[12].setY(y);
        listeLeds[13].setY(y + (1 + groesse) * 1);
        listeLeds[12].setColorOn(rot);
        listeLeds[13].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("13", x - b, y + (1 + groesse) * 1 - 1);
        g.drawString("14", x - b, y + (1 + groesse) * 2 + 1);
        //Button 1
        int index = 0;
        listeButtons[index].setX(x + b);
        listeButtons[index].setY(y + h - listeButtons[index].getH() - 2);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + b + 4, y + h - listeButtons[index].getH() - 3);

        //Fussgngerampel l o NS --> LEDs 18, 19
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx - b + 5;
        y = mY - breiteStrasse / 2 - dy;
        g.fillRect(x, y, b, h);
        int[] x2 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y2 = {y, y, y - hDach};
        g.fillPolygon(x2, y2, 3);
        listeLeds[18].setSize(groesse);
        listeLeds[19].setSize(groesse);
        listeLeds[18].setX(x + dLed);
        listeLeds[19].setX(x + dLed);
        listeLeds[18].setY(y);
        listeLeds[19].setY(y + (1 + groesse) * 1);
        listeLeds[18].setColorOn(rot);
        listeLeds[19].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("19", x + b + 3, y + (1 + groesse) * 1 - 1);
        g.drawString("20", x + b + 3, y + (1 + groesse) * 2 + 1);
        //Button 4
        index = 3;
        listeButtons[index].setX(x - listeButtons[index].getB());
        listeButtons[index].setY(y + h - listeButtons[index].getH() - 2);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x - listeButtons[index].getB() + 4,
            y + h - listeButtons[index].getH() - 3);

        //Fussgngerampel l u SN --> LEDs 20, 21
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx - b + 5;
        y = mY + breiteStrasse / 2 + dy - h;
        g.fillRect(x, y, b, h);
        int[] x3 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y3 = {y + h, y + h, y + h + hDach};
        g.fillPolygon(x3, y3, 3);
        listeLeds[20].setSize(groesse);
        listeLeds[21].setSize(groesse);
        listeLeds[20].setX(x + dLed);
        listeLeds[21].setX(x + dLed);
        listeLeds[20].setY(y + (1 + groesse) * 1);
        listeLeds[21].setY(y + (1 + groesse) * 0);
        listeLeds[20].setColorOn(rot);
        listeLeds[21].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("21", x + b + 3, y + (1 + groesse) * 2 + 1);
        g.drawString("22", x + b + 3, y + (1 + groesse) * 1 - 1);
        //Button 5
        index = 4;
        listeButtons[index].setX(x - listeButtons[index].getB());
        listeButtons[index].setY(y + 1);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x - listeButtons[index].getB() + 4,
            y + listeButtons[index].getH() + 13);

        //Fussgngerampel r u SN --> LEDs 26, 27
        g.setColor(farbeAmpel);
        x = mX + breiteStrasse / 2 + dx;
        y = mY + breiteStrasse / 2 + dy - h;
        g.fillRect(x, y, b, h);
        int[] x4 = {x - dDach, x + b + dDach, x + b / 2};
        int[] y4 = {y + h, y + h, y + h + hDach};
        g.fillPolygon(x4, y4, 3);
        listeLeds[26].setSize(groesse);
        listeLeds[27].setSize(groesse);
        listeLeds[26].setX(x + dLed);
        listeLeds[27].setX(x + dLed);
        listeLeds[26].setY(y + (1 + groesse) * 1);
        listeLeds[27].setY(y + (1 + groesse) * 0);
        listeLeds[26].setColorOn(rot);
        listeLeds[27].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("27", x - b, y + (1 + groesse) * 2 + 1);
        g.drawString("28", x - b, y + (1 + groesse) * 1 - 1);
        //Button 8
        index = 7;
        listeButtons[index].setX(x + b);
        listeButtons[index].setY(y + 1);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + b + 4,
            y + listeButtons[index].getH() + 13);
    }

    private void fussgaengerampelnOW(Graphics g) {
        int mX = this.getX() + getWidth() / 2;
        int mY = this.getY() + getHeight() / 2;
        int dx = 4;
        int dy = 66;
        int h = 16;
        int dDach = 5;
        int hDach = 5;
        int dLed = 3;
        int groesse = h - dLed * 2;
        int b = (1 + groesse) * 2 + 2;

        //Fussgngerampel r o OW --> LEDs 14, 15
        g.setColor(farbeAmpel);
        int x = mX + breiteStrasse / 2 + dx;
        int y = mY - breiteStrasse / 2 - dy;
        g.fillRect(x, y, b, h);
        int[] x1 = {x + b, x + b, x + b + hDach};
        int[] y1 = {y - dDach, y + h + dDach, y + h / 2};
        g.fillPolygon(x1, y1, 3);
        listeLeds[14].setSize(groesse);
        listeLeds[15].setSize(groesse);
        listeLeds[14].setX(x + (1 + groesse) * 1);
        listeLeds[15].setX(x + (1 + groesse) * 0);
        listeLeds[14].setY(y + dLed);
        listeLeds[15].setY(y + dLed);
        listeLeds[14].setColorOn(rot);
        listeLeds[15].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("15", x + (1 + groesse) * 1 + 1, y + h * 0 - 3);
        g.drawString("16", x + (1 + groesse) * 0 - 3, y + h * 0 - 3);
        //Button 2
        int index = 1;
        listeButtons[index].setX(x + 1);
        listeButtons[index].setY(y + h);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + listeButtons[index].getB() + 3,
            y + h + listeButtons[index].getH() - 4);

        //Fussgngerampel l o OW --> LEDs 16, 17
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx - b;
        y = mY - breiteStrasse / 2 - dy;
        g.fillRect(x, y, b, h);
        int[] x2 = {x, x, x - hDach};
        int[] y2 = {y - dDach, y + h + dDach, y + h / 2};
        g.fillPolygon(x2, y2, 3);
        listeLeds[16].setSize(groesse);
        listeLeds[17].setSize(groesse);
        listeLeds[16].setX(x + (1 + groesse) * 0);
        listeLeds[17].setX(x + (1 + groesse) * 1);
        listeLeds[16].setY(y + dLed);
        listeLeds[17].setY(y + dLed);
        listeLeds[16].setColorOn(rot);
        listeLeds[17].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("17", x + (1 + groesse) * 0 - 3, y + h * 0 - 3);
        g.drawString("18", x + (1 + groesse) * 1 + 1, y + h * 0 - 3);
        //Button 3
        index = 2;
        listeButtons[index].setX(x + b - listeButtons[index].getB() - 1);
        listeButtons[index].setY(y + h);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x - 13,
            y + h + listeButtons[index].getH() - 4);

        //Fussgngerampel l u OW --> LEDs 22, 23
        g.setColor(farbeAmpel);
        x = mX - breiteStrasse / 2 - dx - b;
        y = mY + breiteStrasse / 2 + dy - h;
        g.fillRect(x, y, b, h);
        int[] x3 = {x, x, x - hDach};
        int[] y3 = {y - dDach, y + h + dDach, y + h / 2};
        g.fillPolygon(x3, y3, 3);
        listeLeds[22].setSize(groesse);
        listeLeds[23].setSize(groesse);
        listeLeds[22].setX(x + (1 + groesse) * 0);
        listeLeds[23].setX(x + (1 + groesse) * 1);
        listeLeds[22].setY(y + dLed);
        listeLeds[23].setY(y + dLed);
        listeLeds[22].setColorOn(rot);
        listeLeds[23].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("23", x + (1 + groesse) * 0 - 3, y + h + 12);
        g.drawString("24", x + (1 + groesse) * 1 + 1, y + h + 12);
        //Button 6
        index = 5;
        listeButtons[index].setX(x + b - listeButtons[index].getB() - 1);
        listeButtons[index].setY(y - listeButtons[index].getH() - 1);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x - 13, y - 6);

        //Fussgngerampel r u OW --> LEDs 24, 25
        g.setColor(farbeAmpel);
        x = mX + breiteStrasse / 2 + dx;
        y = mY + breiteStrasse / 2 + dy - h;
        g.fillRect(x, y, b, h);
        int[] x4 = {x + b, x + b, x + b + hDach};
        int[] y4 = {y - dDach, y + h + dDach, y + h / 2};
        g.fillPolygon(x4, y4, 3);
        listeLeds[24].setSize(groesse);
        listeLeds[25].setSize(groesse);
        listeLeds[24].setX(x + (1 + groesse) * 1);
        listeLeds[25].setX(x + (1 + groesse) * 0);
        listeLeds[24].setY(y + dLed);
        listeLeds[25].setY(y + dLed);
        listeLeds[24].setColorOn(rot);
        listeLeds[25].setColorOn(gruen);
        g.setColor(Color.black);
        g.drawString("25", x + (1 + groesse) * 1 + 1, y + h + 12);
        g.drawString("26", x + (1 + groesse) * 0 - 3, y + h + 12);
        //Button 7
        index = 6;
        listeButtons[index].setX(x + 1);
        listeButtons[index].setY(y - listeButtons[index].getH() - 1);
        g.setColor(Color.black);
        g.drawString("S" + (index + 1), x + listeButtons[index].getB() + 4, y - 6);

    }

    private void hintergrund(Graphics g) {
        g.setColor(farbeHintergrund);
        g.fillRect(this.getX(), this.getY(), this.getWidth(), this.getHeight());
    }

    private void strasseOstWest(Graphics g) {
        g.setColor(farbeStrae);
        int x = this.getX();
        int y = this.getY() + getHeight() / 2 - breiteStrasse / 2 - rundung;
        int b = getWidth();
        int h = breiteStrasse + rundung * 2;
        g.fillRect(x, y, b, h);
    }

    private void strasseNordSued(Graphics g) {
        g.setColor(farbeStrae);
        int x = this.getX() + getWidth() / 2 - breiteStrasse / 2 - rundung;
        int y = this.getY();
        int b = breiteStrasse + rundung * 2;
        int h = getHeight();
        g.fillRect(x, y, b, h);
    }

    private void fahrbahnmarkierungenOstWest(Graphics g) {
        g.setColor(farbeUmrandung);
        //Haltelinie links
        int dx = 260;
        int mitteX = this.getX() + getWidth() / 2;
        int mitteY = this.getY() + getHeight() / 2;
        int x = mitteX - dx;
        int y = mitteY;
        int b = 10;
        int h = breiteStrasse / 2;
        g.fillRect(x, y, b, h);
        //Haltelinie rechts
        x = mitteX + dx - 10;
        y = mitteY - breiteStrasse / 2;
        b = 10;
        h = breiteStrasse / 2;
        g.fillRect(x, y, b, h);
        //Mittellinie links
        b = 80;
        h = 4;
        for (int i = 0; i < 4; i++) {
            x = mitteX - dx - b - (b + 25) * i + 10;
            y = mitteY - h / 2;
            g.fillRect(x, y, b, h);
        }
        //Mittellinie rechts
        for (int i = 0; i < 4; i++) {
            x = mitteX + dx + (b + 25) * i - 10;
            y = mitteY - h / 2;
            g.fillRect(x, y, b, h);
        }

    }

    private void fahrbahnmarkierungenNordSued(Graphics g) {
        g.setColor(farbeUmrandung);
        //Haltelinie oben
        int dy = 200;
        int h = 10;
        int b = breiteStrasse / 2;
        int mitteX = this.getX() + getWidth() / 2;
        int mitteY = this.getY() + getHeight() / 2;
        int x = mitteX - breiteStrasse / 2;
        int y = mitteY - dy;
        g.fillRect(x, y, b, h);
        //Haltelinie unten
        x = mitteX;
        y = mitteY + dy - 10;
        g.fillRect(x, y, b, h);
        //Mittellinie oben
        b = 4;
        h = 80;
        for (int i = 0; i < 3; i++) {
            x = mitteX - b / 2;
            y = mitteY - dy - h - (h + 25) * i + 10;
        //    y = getY() + (h + 25) * i - 94;
            g.fillRect(x, y, b, h);
        }
        //Mittellinie unten
        for (int i = 0; i < 3; i++) {
            x = mitteX - b / 2;
            y = mitteY + dy + (h + 25) * i - 10;
            g.fillRect(x, y, b, h);
        }
    }

    private void zebrastreifen(Graphics g) {
        g.setColor(farbeUmrandung);
        //Zebrastreifen links
        int d = 120;
        int h = 14;
        int b = 100;
        int mitteX = this.getX() + getWidth() / 2;
        int mitteY = this.getY() + getHeight() / 2;
        int x = mitteX - breiteStrasse / 2 - d;
        int y = mitteY - breiteStrasse / 2 - h;
        for (int i = 0; i < 8; i++) {
            y = y + 2 * h;
            g.fillRect(x, y, b, h);
        }
        //Zebrastreifen rechts
        x = mitteX + breiteStrasse / 2 + d - b;
        y = mitteY - breiteStrasse / 2 - h;
        for (int i = 0; i < 8; i++) {
            y = y + 2 * h;
            g.fillRect(x, y, b, h);
        }
        //Zebrastreifen oben
        d = 64;
        b = 14;
        h = 44;
        x = mitteX - breiteStrasse / 2 - b;
        y = mitteY - breiteStrasse / 2 - d;
        for (int i = 0; i < 8; i++) {
            x = x + 2 * b;
            g.fillRect(x, y, b, h);
        }
        //Zebrastreifen unten
        x = mitteX - breiteStrasse / 2 - b;
        y = mitteY + breiteStrasse / 2 + d - h;
        for (int i = 0; i < 8; i++) {
            x = x + 2 * b;
            g.fillRect(x, y, b, h);
        }
    }

    private void umrandungLinksOben(Graphics g) {
        //weier Streifen on Strae
        g.setColor(farbeUmrandung);
        int x = this.getX() - rundung;
        int y = this.getY() - rundung;
        int b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        int h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        int wx = rundung;
        int wy = rundung;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Fuweg
        g.setColor(farbeRadweg);
        x = x - bStreifen;
        y = y - bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Restflche
        g.setColor(farbeHintergrund);
        x = x - bStreifen;
        y = y - bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
    }

    private void umrandungRechtsOben(Graphics g) {
        //weier Streifen on Strae
        g.setColor(farbeUmrandung);
        int mitteX = this.getX() + getWidth() / 2;
        int x = mitteX + breiteStrasse / 2;
        int y = this.getY() - rundung;
        int b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        int h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        int wx = rundung;
        int wy = rundung;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Fuweg
        g.setColor(farbeRadweg);
        x = x + bStreifen;
        y = y - bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Restflche
        g.setColor(farbeHintergrund);
        x = x + breiteFussweg;
        y = y - bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);

    }

    private void umrandungLinksUnten(Graphics g) {
        g.setColor(farbeUmrandung);
        //weier Streifen on Strae
        int mitteY = this.getY() + getHeight() / 2;
        int x = this.getX() - rundung;
        int y = mitteY + breiteStrasse / 2;;
        int b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        int h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        int wx = rundung;
        int wy = rundung;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Fuweg
        g.setColor(farbeRadweg);
        x = x - bStreifen;
        y = y + bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Restflche
        g.setColor(farbeHintergrund);
        x = x - bStreifen;
        y = y + breiteFussweg;
        b = getWidth() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
    }

    private void umrandungRechtsUnten(Graphics g) {
        int mitteY = this.getY() + getHeight() / 2;
        int mitteX = this.getX() + getWidth() / 2;
        //weier Streifen on Strae
        g.setColor(farbeUmrandung);
        int x = mitteX + breiteStrasse / 2;
        int y = mitteY + breiteStrasse / 2;;
        int b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        int h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        int wx = rundung;
        int wy = rundung;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Fuweg
        g.setColor(farbeRadweg);
        x = x + bStreifen;
        y = y + bStreifen;
        b = getWidth() / 2 - breiteStrasse / 2 + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
        //Restflche
        g.setColor(farbeHintergrund);
        x = x + breiteFussweg;
        y = y + breiteFussweg;
        b = getWidth() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        h = getHeight() / 2 - breiteStrasse / 2 - breiteFussweg + rundung;
        wx = rundung - bStreifen;
        wy = rundung - bStreifen;
        g.fillRoundRect(x, y, b, h, wx, wy);
    }

    /** Creates new form View */
    public View() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">                          
    private void initComponents() {

        addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent evt) {
                    formMouseClicked(evt);
                }
            });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>                        

    private void formMouseClicked(java.awt.event.MouseEvent evt) {                                  
        for (int i = 0; i < listeButtons.length; i++) {
            Button l = listeButtons[i];
            indexButton = l.getIndexPressedButton(evt.getX(), evt.getY());
            //System.out.println("B" + (indexButton+1) + " pressed");
            if (indexButton > -1) {
                Board.updateButtonPressed(indexButton);
                warten(100);
                Board.updateButtonPressed(-1);
                break;
            }
        }
    }                                 

    // Variables declaration - do not modify                     
    // End of variables declaration                   

    private void warten(long ms) {
        long t1 = System.currentTimeMillis();
        long t2 = t1;
        while (t2 - t1 < ms) {
            t2 = System.currentTimeMillis();
        }
    }
}
